; TK3TUT6.ASM 22DEC02 - JOHN BECKER - EPE PIC TUTOR V2
; as TK3TUT4 but using Z and RRF

#DEFINE BANK0 BCF STATUS,5
#DEFINE BANK1 BSF STATUS,5
                 
STATUS          EQU 3                   ; STATUS register
TRISA           EQU 5                   ; Port A direction register
PORTA           EQU 5                   ; Port A data register
TRISB           EQU 6                   ; Port B direction register
PORTB           EQU 6                   ; Port B data register
W               EQU 0                   ; Working register flag
F               EQU 1                   ; File register flag
C               EQU 0                   ; Carry flag
Z               EQU 2                   ; Zero flag

                ORG 0                   ; Reset Vector address
                GOTO 5                  ; go to PIC address location 5
                ORG 4                   ; Interrupt Vector address
                GOTO 5                  ; go to PIC address location 5
                ORG 5                   ; Start of Program Memory at location 5
                 
                clrf PORTA              ; clear Port A data register
                clrf PORTB              ; clear Port B data register
                BANK1                   ; BANK 1
                clrf TRISA              ; Port A direction register for output
                clrf TRISB              ; Port B direction register for output
                BANK0                   ; BANK 0
                 
LOOP1           movlw B'10000000'               ; load value of 128 into Working register
                movwf PORTB             ; load this value (%10000000) into Port B
                bcf STATUS,C            ; clear Carry bit
                 
LOOP2           rrf PORTB,F             ; rotate value of PORTB right by 1 logical place
                movf PORTB,F            ; cause status of Zero bit to be registered
                                        ; (the command movf PORTB,W has the same effect)
                btfss STATUS,Z          ; check if the Zero flag (bit 2) of the STATUS
                                        ; register has been set to high, indicating that
                                        ; PORTB has returned to a value 0 after it has been
                                        ; shifted right 8 times
                goto LOOP2              ; this command is actioned only if PORTB is not yet 0
                                        ; the program jumping back to the address called LOOP2
                goto LOOP1              ; this command is only actioned when PORTB now = 0
                 
                end                     ; final statement
